//      
class EVENTBASE
{
private:
  static EVENTBASE* AllEventClasses[];

  static int GetAllEventClassesSize( const EVENTBASE &This )
  {
    const int Size = ArraySize(AllEventClasses); // : unresolved static variable 'EVENTBASE::AllEventClasses'.
    int Pos = 0;

    for (int i = 0; i < Size; i++)
    {
      AllEventClasses[Pos] = AllEventClasses[i];

      if ((CheckPointer(AllEventClasses[i]) != POINTER_INVALID) && (AllEventClasses[i] != GetPointer(This)))
        Pos++;
    }

    return(Pos);
  }

// -  (       )
// ,  TakeProfit - .     - .  ..
//          OnChartEvent
  virtual void Event( const int id, const long &lparam, const double &dparam, const string &sparam )
  {
    return;
  }

// -  
  virtual void EventTimer( void )
  {
    return;
  }

public:
  EVENTBASE( bool Add = TRUE )
  {
    if (Add)
    {
      const int Pos = GetAllEventClassesSize(this);

      ArrayResize(AllEventClasses, Pos + 1);

      AllEventClasses[Pos] = GetPointer(this);
    }
  }

  ~EVENTBASE( void )
  {
    ArrayResize(AllEventClasses, GetAllEventClassesSize(this));
  }

//     
  static void MyEvent( const int id, const long &lparam, const double &dparam, const string &sparam )
  {
    const int Size = ArraySize(AllEventClasses);

    for (int i = 0; i < Size; i++)
      if (CheckPointer(AllEventClasses[i]) != POINTER_INVALID)
        AllEventClasses[i].Event(id, lparam, dparam, sparam);

    return;
  }

//       
  static void MyEventTimer( void )
  {
    const int Size = ArraySize(AllEventClasses);

    for (int i = 0; i < Size; i++)
      if (CheckPointer(AllEventClasses[i]) != POINTER_INVALID)
        AllEventClasses[i].EventTimer();

    return;
  }
};

EVENTBASE* EVENTBASE::AllEventClasses[];